/*    SpeedyType is free software: you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation, either version 3 of the License, or
      (at your option) any later version.

      SpeedyType is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.

      You should have received a copy of the GNU General Public License
      along with SpeedyType.  If not, see <http://www.gnu.org/licenses/>.

*/


class Word
{

public:
	Word(sf::Font &font, std::string str)
	{
		_word.setString(str);
		_word.setFont(font);
		_word.setOutlineThickness(1);
		_word.setOutlineColor(sf::Color::Black);
		_word.setCharacterSize(this->size);
		_word.setFillColor(this->color);
		_word.setPosition(0,rand()%(380-100+1)+100);
	}

	int getX()
	{
		return _word.getPosition().x;
	}

	int getY()
	{
		return _word.getPosition().y;
	}

	sf::FloatRect getGlobalBounds()
	{
		return this->_word.getGlobalBounds();
	}

	void generateNewPosition()
	{
		_word.setPosition(0,rand()%(380-100+1)+100);
	}

	void move()
	{
		_word.setPosition(_word.getPosition().x+this->vel,_word.getPosition().y);
	}

	void select()
	{
		this->_draw=true;
	}

	bool isDraw()
	{
		return this->_draw;
	}

	std::string getText()
	{
		return _word.getString();
	}

	void warning()
	{
		_word.setFillColor(sf::Color::Red);
	}

	void alert()
	{
		_word.setFillColor(sf::Color(0xff,0xa5,0x00));
	}

	void draw(sf::RenderWindow &window)
	{
		window.draw(_word);
	}

private:

	sf::Color color=sf::Color::White;
	short size=17;
	short vel=20;
	bool _draw=false;
	sf::Text _word;
};
